Public Class AddLoginForm

    Function AddLoginChecks() As Boolean

        AddLoginChecks = False

        If ComboLogin.Text.Length = 0 Then
            MessageBox.Show("Please enter login.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        Dim nCount As Integer
        Dim sDigit As String = "0123456789"

        For nCount = 0 To ComboLogin.Text.Length - 1
            If sDigit.IndexOf(ComboLogin.Text.Chars(nCount)) = -1 Then
                MessageBox.Show("Login should contain only numerals 0 through 9. For example: 12, 324323, 800122, 2109756 etc.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Function
            End If
        Next

        If EditPassword.Text.Length = 0 Then
            MessageBox.Show("Please enter login password.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        If ComboLogin.Text.Length > 20 Or EditPassword.Text.Length > 20 Then
            MessageBox.Show("Login and password size should not be more 20.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        If ComboLogin.Text.Substring(0, 2) = "00" Then
            MessageBox.Show("Please donot enter 00 as login prefix. 00 prefix is use to prepare dial plan.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        If ListBoxEnableCodec.Items.Count = 0 Then
            MessageBox.Show("Please select a codec.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        AddLoginChecks = True

    End Function

    Private Sub BtnRemoveLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveLogin.Click

        If ComboLogin.Text.Length = 0 Then
            MessageBox.Show("Please enter login.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim objParamList As ArrayList = New ArrayList
        objParamList.Add(ComboLogin.Text)

        MainForm.m_objMainForm.SendCommand("RemoveUser", objParamList)

    End Sub

    Private Sub BtnAddLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddLogin.Click

        If AddLoginChecks() = False Then
            Exit Sub
        End If

        If ComboLogin.FindStringExact(ComboLogin.Text) <> -1 Then

            If MessageBox.Show("Login already exist, do you want to update it?", "VaxTeleSIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) = Windows.Forms.DialogResult.No Then
                Exit Sub
            End If

        End If

        Dim objCodec As New cCodec
        Dim sCodec As String = ""

        Dim nCount As Integer

        For nCount = 0 To ListBoxEnableCodec.Items.Count - 1
            sCodec += objCodec.GetCodecNo(ListBoxEnableCodec.Items.Item(nCount))
        Next

        Dim objParamList As ArrayList = New ArrayList

        objParamList.Add(ComboLogin.Text)
        objParamList.Add(EditPassword.Text)
        objParamList.Add(sCodec)

        If CheckBoxStealthListener.Checked = True Then
            objParamList.Add("STEALTH-YES")
        Else
            objParamList.Add("STEALTH-NO")
        End If

        If CheckBoxBlockAccount.Checked = True Then
            objParamList.Add("BLOCK-YES")
        Else
            objParamList.Add("BLOCK-NO")
        End If

        MainForm.m_objMainForm.SendCommand("AddUser", objParamList)

    End Sub

    Private Sub UpdateDlgContent(ByVal sLogin As String, ByVal sPassword As String, ByVal sCodecList As String, ByVal sStealth As String, ByVal sBlock As String)

        If ComboLogin.Text <> sLogin Then
            Exit Sub
        End If

        EditPassword.Text = sPassword

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        Dim nCount As Integer
        Dim objCodec As New cCodec

        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC
            ListBoxDisableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next

        Dim sCodecName As String

        For nCount = 0 To sCodecList.Length - 1
            sCodecName = objCodec.GetCodecName(sCodecList(nCount))
            ListBoxEnableCodec.Items.Add(sCodecName)
            ListBoxDisableCodec.Items.Remove(sCodecName)
        Next

        If sBlock = "BLOCK-YES" Then
            CheckBoxBlockAccount.Checked = True
        Else
            CheckBoxBlockAccount.Checked = False
        End If

        If sStealth = "STEALTH-YES" Then
            CheckBoxStealthListener.Checked = True
        Else
            CheckBoxStealthListener.Checked = False
        End If

    End Sub

    Private Sub BtnDisableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDisableCodec.Click

        If ListBoxEnableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxDisableCodec.Items.Add(ListBoxEnableCodec.SelectedItem.ToString)
        ListBoxEnableCodec.Items.Remove(ListBoxEnableCodec.SelectedItem)

    End Sub

    Private Sub BtnEnableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEnableCodec.Click
        If ListBoxDisableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxEnableCodec.Items.Add(ListBoxDisableCodec.SelectedItem.ToString)
        ListBoxDisableCodec.Items.Remove(ListBoxDisableCodec.SelectedItem)
    End Sub

    Private Sub ComboLogin_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboLogin.SelectedIndexChanged
        Dim objParamList As ArrayList = New ArrayList
        objParamList.Add(ComboLogin.SelectedItem.ToString())

        MainForm.m_objMainForm.SendCommand("UserInfo", objParamList)
    End Sub

    Private Sub ClearDlgContent()

        ComboLogin.Text = ""
        EditPassword.Text = ""

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        CheckBoxBlockAccount.Checked = False
        CheckBoxStealthListener.Checked = False

        ListBoxEnableCodec.Items.Add(cCodec.G711U_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G711A_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.ILBC_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G610_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G729_TEXT)

    End Sub

    Private Sub BtnClearLoginDlg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearLoginDlg.Click
        ClearDlgContent()
    End Sub

    Private Sub AddLoginForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MainForm.m_objMainForm.SendCommand("ShowUsers", Nothing)
        ClearDlgContent()

    End Sub

    Public Sub OnTelnetCommand(ByVal sCommand As String, ByRef objParamList As ArrayList)

        If String.Compare(sCommand, "ShowUsers", True) = 0 Then

            Dim nCount As Integer

            For nCount = 0 To objParamList.Count - 1
                ComboLogin.Items.Add(objParamList.Item(nCount))
            Next

            If ComboLogin.Items.Count > 0 Then
                ComboLogin.SelectedIndex = 0
            End If

            Exit Sub
        End If

        If String.Compare(sCommand, "UserInfo", True) = 0 And objParamList.Count = 5 Then

            Dim sLogin As String = objParamList.Item(0)
            Dim sPassword As String = objParamList.Item(1)
            Dim sCodecList As String = objParamList.Item(2)
            Dim sStealth As String = objParamList.Item(3)
            Dim sBlock As String = objParamList.Item(4)

            UpdateDlgContent(sLogin, sPassword, sCodecList, sStealth, sBlock)
            Exit Sub

        End If

        If String.Compare(sCommand, "RemoveUser", True) = 0 And objParamList.Count = 1 Then

            Dim nIndex As Integer = ComboLogin.FindStringExact(objParamList.Item(0))
            If nIndex = -1 Then
                Exit Sub
            End If

            ComboLogin.Items.RemoveAt(nIndex)

            MessageBox.Show("Login removed successfully!", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            ClearDlgContent()

            Exit Sub
        End If

        If String.Compare(sCommand, "AddUser", True) = 0 And objParamList.Count = 1 Then

            ComboLogin.Items.Add(objParamList.Item(0))
            MessageBox.Show("Login created successfully", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

            Exit Sub
        End If

        If String.Compare(sCommand, "UpdateUser", True) = 0 And objParamList.Count = 1 Then

            MessageBox.Show("Login updated successfully", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

    End Sub

End Class