Public Class MainForm

    Public Shared m_objMainForm As MainForm

    Private m_objGeneralForm As GeneralForm = New GeneralForm
    Private m_objAddLoginForm As AddLoginForm = New AddLoginForm
    Private m_objAddLineForm As AddLineForm = New AddLineForm
    Private m_objAddDialPlanForm As AddDialPlanForm = New AddDialPlanForm
    Private m_objAddQueueForm As AddQueueForm = New AddQueueForm
    Private m_objErrorLogForm As ErrorLogForm = New ErrorLogForm
    Private m_objStatusLogForm As StatusLogForm = New StatusLogForm

    Public m_objTelnetClient As New cTelnetClient

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_objMainForm = Me

        Dim objAuthForm As New AuthForm

        objAuthForm.m_objTelnetClient = m_objTelnetClient
        objAuthForm.ShowDialog()

        If objAuthForm.m_bConnected = False Then
            Close()
            Exit Sub
        End If

        m_objGeneralForm.TopLevel = False
        m_objGeneralForm.Visible = True
        m_objGeneralForm.FormBorderStyle = FormBorderStyle.None
        m_objGeneralForm.Dock = DockStyle.Fill
        TabCtrlMain.TabPages.Item(0).Controls.Add(m_objGeneralForm)

        m_objAddLoginForm.TopLevel = False
        m_objAddLoginForm.Visible = True
        m_objAddLoginForm.FormBorderStyle = FormBorderStyle.None
        m_objAddLoginForm.Dock = DockStyle.Fill
        TabCtrlMain.TabPages.Item(1).Controls.Add(m_objAddLoginForm)

        m_objAddLineForm.TopLevel = False
        m_objAddLineForm.Visible = True
        m_objAddLineForm.FormBorderStyle = FormBorderStyle.None
        m_objAddLineForm.Dock = DockStyle.Fill
        TabCtrlMain.TabPages.Item(2).Controls.Add(m_objAddLineForm)

        m_objAddDialPlanForm.TopLevel = False
        m_objAddDialPlanForm.Visible = True
        m_objAddDialPlanForm.FormBorderStyle = FormBorderStyle.None
        m_objAddDialPlanForm.Dock = DockStyle.Fill
        TabCtrlMain.TabPages.Item(3).Controls.Add(m_objAddDialPlanForm)

        m_objAddQueueForm.TopLevel = False
        m_objAddQueueForm.Visible = True
        m_objAddQueueForm.FormBorderStyle = FormBorderStyle.None
        m_objAddQueueForm.Dock = DockStyle.Fill
        TabCtrlMain.TabPages.Item(4).Controls.Add(m_objAddQueueForm)

        m_objErrorLogForm.TopLevel = False
        m_objErrorLogForm.Visible = True
        m_objErrorLogForm.FormBorderStyle = FormBorderStyle.None
        m_objErrorLogForm.Dock = DockStyle.Fill
        TabCtrlMain.TabPages.Item(5).Controls.Add(m_objErrorLogForm)

        m_objStatusLogForm.TopLevel = False
        m_objStatusLogForm.Visible = True
        m_objStatusLogForm.FormBorderStyle = FormBorderStyle.None
        m_objStatusLogForm.Dock = DockStyle.Fill
        TabCtrlMain.TabPages.Item(6).Controls.Add(m_objStatusLogForm)

    End Sub

    Public Sub SetPageTitle(ByVal sTitle As String, ByVal nPageNo As Integer)
        TabCtrlMain.TabPages.Item(nPageNo).Text = sTitle
    End Sub

    Public Sub InvokeTelnetRecv(ByVal sCommand As String, ByRef objParamList As ArrayList)

        Dim MethodParam() As Object = New Object() {sCommand, objParamList}
        Invoke(New OnTelnetRecv(AddressOf OnTelnetCommand), MethodParam)

    End Sub

    Private Delegate Sub OnTelnetRecv(ByVal sCommand As String, ByRef objParamList As ArrayList)

    Private Sub TabCtrlMain_DrawItem(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles TabCtrlMain.DrawItem

        Dim g As Graphics = e.Graphics
        Dim f As Font = New Font(e.Font, FontStyle.Bold)
        Dim b As New SolidBrush(SystemColors.Control)
        g.FillRectangle(b, e.Bounds)

        b.Color = Color.Black
        g.DrawString(Me.TabCtrlMain.TabPages(e.Index).Text, e.Font, b, e.Bounds.X + 2, e.Bounds.Y + 2)

        'g.DrawString(Me.TabCtrlMain.TabPages(e.Index).Text, f, b, e.Bounds.X + 2, e.Bounds.Y + 2)

        'If e.Index = Me.TabCtrlMain.SelectedIndex Then
        'b.Color = Color.Blue
        'g.DrawString(Me.TabCtrlMain.TabPages(e.Index).Text, f, b, e.Bounds.X + 2, e.Bounds.Y + 2)
        'Else
        'b.Color = Color.Black
        'g.DrawString(Me.TabCtrlMain.TabPages(e.Index).Text, e.Font, b, e.Bounds.X + 2, e.Bounds.Y + 2)
        'End If

        b.Dispose()
        f.Dispose()

    End Sub

    Public Sub OnTelnetCommand(ByVal sCommand As String, ByRef objParamList As ArrayList)

        If String.Compare(sCommand, "GetDialToneMusic", True) = 0 Or String.Compare(sCommand, "GetStealthMusic", True) = 0 Or String.Compare(sCommand, "GetHoldMusic", True) = 0 Or String.Compare(sCommand, "StatusServerSIP", True) = 0 Then
            m_objGeneralForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "GetCallCount", True) = 0 Or String.Compare(sCommand, "GetUserCount", True) = 0 Then
            m_objGeneralForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "GetUsageCPU", True) = 0 Or String.Compare(sCommand, "GetAvailMEM", True) = 0 Then
            m_objGeneralForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "GetCOMM", True) = 0 Or String.Compare(sCommand, "SetCOMM", True) = 0 Then
            m_objGeneralForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        '///////////////////////////////////////

        If String.Compare(sCommand, "ShowUsers", True) = 0 Then
            m_objAddLoginForm.OnTelnetCommand(sCommand, objParamList)
            m_objAddQueueForm.OnTelnetCommand(sCommand, objParamList)
            m_objAddLineForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "RemoveUser", True) = 0 Or String.Compare(sCommand, "AddUser", True) = 0 Then
            m_objAddLoginForm.OnTelnetCommand(sCommand, objParamList)
            m_objAddQueueForm.OnTelnetCommand(sCommand, objParamList)
            m_objAddLineForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "UpdateUser", True) = 0 Or String.Compare(sCommand, "UserInfo", True) = 0 Then
            m_objAddLoginForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        '///////////////////////////////////////

        If String.Compare(sCommand, "RemoveQueue", True) = 0 Or String.Compare(sCommand, "AddQueue", True) = 0 Or String.Compare(sCommand, "ShowQueues", True) = 0 Then
            m_objAddQueueForm.OnTelnetCommand(sCommand, objParamList)
            m_objAddLineForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "UpdateQueue", True) = 0 Or String.Compare(sCommand, "QueueInfo", True) = 0 Then
            m_objAddQueueForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        '////////////////////////////////////////

        If String.Compare(sCommand, "RemoveLine", True) = 0 Or String.Compare(sCommand, "AddLine", True) = 0 Or String.Compare(sCommand, "ShowLines", True) = 0 Then
            m_objAddLineForm.OnTelnetCommand(sCommand, objParamList)
            m_objAddDialPlanForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "UpdateLine", True) = 0 Or String.Compare(sCommand, "LineInfo", True) = 0 Or String.Compare(sCommand, "ShowLines", True) = 0 Then
            m_objAddLineForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        '////////////////////////////////////////

        If String.Compare(sCommand, "ShowDialPlans", True) = 0 Then
            m_objAddDialPlanForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "RemoveDialPlan", True) = 0 Or String.Compare(sCommand, "AddDialPlan", True) = 0 Then
            m_objAddDialPlanForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "UpdateDialPlan", True) = 0 Or String.Compare(sCommand, "DialPlanInfo", True) = 0 Then
            m_objAddDialPlanForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        '////////////////////////////////////////

        If String.Compare(sCommand, "ErrorLog", True) = 0 Then
            m_objErrorLogForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        If String.Compare(sCommand, "StatusLog", True) = 0 Then
            m_objStatusLogForm.OnTelnetCommand(sCommand, objParamList)
            Exit Sub
        End If

        '////////////////////////////////////////

        If String.Compare(sCommand, "MSG", True) = 0 And objParamList.Count = 1 Then
            MessageBox.Show(objParamList.Item(0), "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

    End Sub

    Public Sub SendCommand(ByVal sCommand As String, ByRef objParamList As ArrayList)
        m_objTelnetClient.SendCommand(sCommand, objParamList)
    End Sub

    Public Sub ParseToList(ByVal sString As String, ByRef objStrList As ArrayList)

        While sString.Length <> 0

            Dim nEnd As Integer = sString.IndexOf(",")

            If nEnd = -1 Then
                objStrList.Add(sString)
                Exit While
            End If

            objStrList.Add(sString.Substring(0, nEnd))
            sString = sString.Remove(0, nEnd + 1)

        End While

    End Sub

    Private Sub MainForm_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        m_objTelnetClient.CloseSocket()
    End Sub
End Class
