
Imports Microsoft.Win32

Public Class cLineReg

    Public m_sDisplayName As String
    Public m_sUserName As String
    Public m_sAuthUser As String
    Public m_sPassword As String
    Public m_sRealm As String
    Public m_sProxy As String
    Public m_sOutboundProxy As String
    Public m_bRegister As Boolean
    Public m_sInCallType As String
    Public m_sInCallTo As String
    Public m_sCodec As String

End Class

Public Class cQueueReg

    Public m_sPlayWave As String
    Public m_sPressDigitPlayWave As String
    Public m_objQueueOPList As ArrayList
    Public m_objPressDigitList As ArrayList
    Public m_objPressDigitUserList As ArrayList

End Class

Public Class cLoginReg

    Public m_sPassword As String
    Public m_sCodec As String
    Public m_bBlock As Boolean
    Public m_bStealth As Boolean

End Class

Public Class cDialPlanReg

    Public m_sLineName As String
    Public m_sCallPrefix As String

End Class


Public Class cRegistry

    Private m_hKey As RegistryKey = Nothing

    Public Sub New()
        m_hKey = Registry.LocalMachine.CreateSubKey("SOFTWARE\VaxTeleSrvSIP")
    End Sub

    Protected Overrides Sub Finalize()

        If m_hKey Is Nothing Then
            Exit Sub
        End If

        m_hKey.Close()
    End Sub

    Public Function GetStealthListenerMusic() As String

        If m_hKey Is Nothing Then
            GetStealthListenerMusic = ""
            Exit Function
        End If

        GetStealthListenerMusic = m_hKey.GetValue("StealthListenMusic", "")
    End Function

    Public Function SetStealthListenerMusic(ByVal sPlayWave As String) As Boolean

        If m_hKey Is Nothing Then
            SetStealthListenerMusic = False
            Exit Function
        End If

        m_hKey.SetValue("StealthListenMusic", sPlayWave)

        SetStealthListenerMusic = True

    End Function

    Public Function GetHoldMusic() As String

        If m_hKey Is Nothing Then
            GetHoldMusic = ""
            Exit Function
        End If

        GetHoldMusic = m_hKey.GetValue("HoldMusic", "")

    End Function

    Public Function SetHoldMusic(ByVal sPlayWave As String) As Boolean

        If m_hKey Is Nothing Then
            SetHoldMusic = False
            Exit Function
        End If

        m_hKey.SetValue("HoldMusic", sPlayWave)
        SetHoldMusic = True

    End Function

    Public Function GetDialToneMusic() As String

        If m_hKey Is Nothing Then
            GetDialToneMusic = ""
            Exit Function
        End If

        GetDialToneMusic = m_hKey.GetValue("DialToneMusic", "")

    End Function

    Public Function SetDialToneMusic(ByVal sPlayWave As String) As Boolean

        If m_hKey Is Nothing Then
            SetDialToneMusic = False
            Exit Function
        End If

        m_hKey.SetValue("DialToneMusic", sPlayWave)
        SetDialToneMusic = True

    End Function

    Public Function GetStartServer() As Boolean

        If m_hKey Is Nothing Then
            GetStartServer = False
            Exit Function
        End If

        GetStartServer = m_hKey.GetValue("ServerStart", True)
    End Function

    Public Function SetStartServer(ByVal bEnable As Boolean) As Boolean

        If m_hKey Is Nothing Then
            SetStartServer = False
            Exit Function
        End If

        m_hKey.SetValue("ServerStart", bEnable, RegistryValueKind.DWord)
        SetStartServer = True
    End Function

    Public Function SetComm(ByVal sListenIP As String, ByVal sListenPort As String, ByVal sDominRealm As String) As Boolean

        If m_hKey Is Nothing Then
            SetComm = False
            Exit Function
        End If

        m_hKey.SetValue("ListenIP", sListenIP)
        m_hKey.SetValue("ListenPort", sListenPort)
        m_hKey.SetValue("DomainRealm", sDominRealm)

        SetComm = True

    End Function

    Public Function GetComm(ByRef sListenIP As String, ByRef sListenPort As String, ByRef sDominRealm As String) As Boolean

        If m_hKey Is Nothing Then
            GetComm = False
            Exit Function
        End If

        sListenIP = m_hKey.GetValue("ListenIP", "")
        sListenPort = m_hKey.GetValue("ListenPort", "5060")
        sDominRealm = m_hKey.GetValue("DomainRealm", "")

        GetComm = True

    End Function

    Public Function RemoveQueue(ByVal sQueue As String) As Boolean

        If m_hKey Is Nothing Then
            RemoveQueue = False
            Exit Function
        End If

        m_hKey.DeleteSubKey("Queue\" + sQueue)
        RemoveQueue = True

    End Function

    Public Function EnumQueue(ByRef objQueueList As ArrayList) As Boolean

        If m_hKey Is Nothing Then
            EnumQueue = False
            Exit Function
        End If

        Dim hKey As RegistryKey = m_hKey.OpenSubKey("Queue", False)

        If hKey Is Nothing Then
            EnumQueue = False
            Exit Function
        End If

        Dim arrayQueue As String() = hKey.GetSubKeyNames()

        If arrayQueue Is Nothing Then
            EnumQueue = False
            Exit Function
        End If

        Dim nCount As Integer
        For nCount = 0 To arrayQueue.Length - 1
            objQueueList.Add(arrayQueue(nCount))
        Next

        hKey.Close()
        EnumQueue = True

    End Function

    Public Function GetQueue(ByVal sQueue As String, ByRef objQueueReg As cQueueReg) As Boolean

        If m_hKey Is Nothing Then
            GetQueue = False
            Exit Function
        End If

        Dim hKey As RegistryKey
        Dim nCount As Integer
        Dim sValue As String

        hKey = m_hKey.OpenSubKey("Queue\" + sQueue, False)
        If hKey Is Nothing Then
            GetQueue = False
            Exit Function
        End If

        objQueueReg.m_objQueueOPList = New ArrayList

        For nCount = 0 To 100000
            sValue = hKey.GetValue("op-" + nCount.ToString)
            If sValue Is Nothing Then
                Exit For
            End If
            objQueueReg.m_objQueueOPList.Add(sValue)
        Next nCount

        objQueueReg.m_objPressDigitList = New ArrayList

        For nCount = 0 To 100000
            sValue = hKey.GetValue("digit-" + nCount.ToString)
            If sValue Is Nothing Then
                Exit For
            End If
            objQueueReg.m_objPressDigitList.Add(sValue)
        Next nCount

        objQueueReg.m_objPressDigitUserList = New ArrayList

        For nCount = 0 To 100000
            sValue = hKey.GetValue("digituser-" + nCount.ToString)
            If sValue Is Nothing Then
                Exit For
            End If
            objQueueReg.m_objPressDigitUserList.Add(sValue)
        Next nCount

        objQueueReg.m_sPlayWave = hKey.GetValue("playwave", "")
        objQueueReg.m_sPressDigitPlayWave = hKey.GetValue("digitplaywave", "")

        hKey.Close()
        GetQueue = True

    End Function

    Public Function SetQueue(ByVal sQueue As String, ByRef objQueueReg As cQueueReg) As Boolean

        If m_hKey Is Nothing Then
            SetQueue = False
            Exit Function
        End If

        Dim hKey As RegistryKey
        Dim nCount As Integer

        hKey = m_hKey.CreateSubKey("Queue\" + sQueue)
        If hKey Is Nothing Then
            SetQueue = False
            Exit Function
        End If

        hKey.SetValue("playwave", objQueueReg.m_sPlayWave)

        For nCount = 0 To objQueueReg.m_objQueueOPList.Count - 1
            hKey.SetValue("op-" + nCount.ToString, objQueueReg.m_objQueueOPList(nCount))
        Next nCount

        For nCount = 0 To objQueueReg.m_objPressDigitList.Count - 1
            hKey.SetValue("digit-" + nCount.ToString, objQueueReg.m_objPressDigitList(nCount))
        Next nCount

        For nCount = 0 To objQueueReg.m_objPressDigitUserList.Count - 1
            hKey.SetValue("digituser-" + nCount.ToString, objQueueReg.m_objPressDigitUserList(nCount))
        Next nCount

        hKey.SetValue("digitplaywave", objQueueReg.m_sPressDigitPlayWave)

        hKey.Close()
        SetQueue = True

    End Function

    Public Function IsQueueExist(ByVal sQueue As String) As Boolean

        If m_hKey Is Nothing Then
            IsQueueExist = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.OpenSubKey("Queue\" + sQueue, False)
        If hKey Is Nothing Then
            IsQueueExist = False
            Exit Function
        End If

        hKey.Close()
        IsQueueExist = True

    End Function

    Public Function RemoveLogin(ByVal sLogin As String) As Boolean

        If m_hKey Is Nothing Then
            RemoveLogin = False
            Exit Function
        End If

        m_hKey.DeleteSubKey("Login\" + sLogin)
        RemoveLogin = True

    End Function

    Public Function EnumLogin(ByRef objLoginList As ArrayList) As Boolean

        If m_hKey Is Nothing Then
            EnumLogin = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.OpenSubKey("Login", False)
        If hKey Is Nothing Then
            EnumLogin = False
            Exit Function
        End If

        Dim arrayLogin As String() = hKey.GetSubKeyNames()

        If arrayLogin Is Nothing Then
            EnumLogin = False
            Exit Function
        End If

        Dim nCount As Integer
        For nCount = 0 To arrayLogin.Length - 1
            objLoginList.Add(arrayLogin(nCount))
        Next

        hKey.Close()
        EnumLogin = True

    End Function

    Public Function SetLogin(ByVal sLogin As String, ByVal objLoginReg As cLoginReg) As Boolean

        If m_hKey Is Nothing Then
            SetLogin = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.CreateSubKey("Login\" + sLogin)
        If hKey Is Nothing Then
            SetLogin = False
            Exit Function
        End If

        hKey.SetValue("password", objLoginReg.m_sPassword)
        hKey.SetValue("codec", objLoginReg.m_sCodec)
        hKey.SetValue("block", objLoginReg.m_bBlock, RegistryValueKind.DWord)
        hKey.SetValue("stealth", objLoginReg.m_bStealth, RegistryValueKind.DWord)

        hKey.Close()
        SetLogin = True

    End Function

    Public Function GetLogin(ByVal sLogin As String, ByRef objLoginReg As cLoginReg) As Boolean

        If m_hKey Is Nothing Then
            GetLogin = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.OpenSubKey("Login\" + sLogin, False)
        If hKey Is Nothing Then
            GetLogin = False
            Exit Function
        End If

        objLoginReg.m_sPassword = hKey.GetValue("password", "")
        objLoginReg.m_bBlock = hKey.GetValue("block", True)
        objLoginReg.m_bStealth = hKey.GetValue("stealth", False)
        objLoginReg.m_sCodec = hKey.GetValue("codec", "32014")

        hKey.Close()
        GetLogin = True

    End Function

    Public Function IsLoginExist(ByVal sLogin As String) As Boolean

        If m_hKey Is Nothing Then
            IsLoginExist = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.OpenSubKey("Login\" + sLogin, False)
        If hKey Is Nothing Then
            IsLoginExist = False
            Exit Function
        End If

        hKey.Close()
        IsLoginExist = True

    End Function

    Public Function EnumLine(ByRef objLineList As ArrayList) As Boolean

        If m_hKey Is Nothing Then
            EnumLine = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.OpenSubKey("Line", False)
        If hKey Is Nothing Then
            EnumLine = False
            Exit Function
        End If

        Dim arrayLine As String() = hKey.GetSubKeyNames()

        If arrayLine Is Nothing Then
            EnumLine = False
            Exit Function
        End If

        Dim nCount As Integer
        For nCount = 0 To arrayLine.Length - 1
            objLineList.Add(arrayLine(nCount))
        Next

        EnumLine = True

    End Function

    Public Function SetLine(ByVal sLineName As String, ByVal objLineReg As cLineReg) As Boolean

        If m_hKey Is Nothing Then
            SetLine = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.CreateSubKey("Line\" + sLineName)
        If hKey Is Nothing Then
            SetLine = False
            Exit Function
        End If

        hKey.SetValue("displayname", objLineReg.m_sDisplayName)
        hKey.SetValue("username", objLineReg.m_sUserName)
        hKey.SetValue("authuser", objLineReg.m_sAuthUser)
        hKey.SetValue("password", objLineReg.m_sPassword)
        hKey.SetValue("realm", objLineReg.m_sRealm)
        hKey.SetValue("proxy", objLineReg.m_sProxy)
        hKey.SetValue("outboundproxy", objLineReg.m_sOutboundProxy)
        hKey.SetValue("codec", objLineReg.m_sCodec)
        hKey.SetValue("regonstartup", objLineReg.m_bRegister, RegistryValueKind.DWord)
        hKey.SetValue("incalltype", objLineReg.m_sInCallType)
        hKey.SetValue("incallto", objLineReg.m_sInCallTo)

        hKey.Close()
        SetLine = True

    End Function

    Public Function GetLine(ByVal sLineName As String, ByRef objLineReg As cLineReg) As Boolean

        If m_hKey Is Nothing Then
            GetLine = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.OpenSubKey("Line\" + sLineName, False)
        If hKey Is Nothing Then
            GetLine = False
            Exit Function
        End If

        objLineReg.m_sDisplayName = hKey.GetValue("displayname", "")
        objLineReg.m_sUserName = hKey.GetValue("username", "")
        objLineReg.m_sAuthUser = hKey.GetValue("authuser", "")
        objLineReg.m_sPassword = hKey.GetValue("password", "")
        objLineReg.m_sRealm = hKey.GetValue("realm", "")
        objLineReg.m_sProxy = hKey.GetValue("proxy", "")
        objLineReg.m_sOutboundProxy = hKey.GetValue("outboundproxy", "")

        objLineReg.m_sCodec = hKey.GetValue("codec", "32014")
        objLineReg.m_bRegister = hKey.GetValue("regonstartup", False)

        objLineReg.m_sInCallType = hKey.GetValue("incalltype", "")
        objLineReg.m_sInCallTo = hKey.GetValue("incallto", "")

        hKey.Close()
        GetLine = True

    End Function

    Public Function IsLineExist(ByVal sLineName As String) As Boolean

        If m_hKey Is Nothing Then
            IsLineExist = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.OpenSubKey("Line\" + sLineName, False)
        If hKey Is Nothing Then
            IsLineExist = False
            Exit Function
        End If

        hKey.Close()
        IsLineExist = True

    End Function

    Public Function RemoveLine(ByVal sLineName As String) As Boolean

        If m_hKey Is Nothing Then
            RemoveLine = False
            Exit Function
        End If

        m_hKey.DeleteSubKey("Line\" + sLineName)
        RemoveLine = True

    End Function

    Public Function EnumDialPlan(ByRef objUserPrefixList As ArrayList) As Boolean

        If m_hKey Is Nothing Then
            EnumDialPlan = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.OpenSubKey("DialPlan", False)
        If hKey Is Nothing Then
            EnumDialPlan = False
            Exit Function
        End If

        Dim arrayUserPrefix As String() = hKey.GetSubKeyNames()

        If arrayUserPrefix Is Nothing Then
            EnumDialPlan = False
            Exit Function
        End If

        Dim nCount As Integer
        For nCount = 0 To arrayUserPrefix.Length - 1
            objUserPrefixList.Add(arrayUserPrefix(nCount))
        Next

        hKey.Close()
        EnumDialPlan = True

    End Function

    Public Function RemoveDialPlan(ByVal sUserPrefix As String) As Boolean

        If m_hKey Is Nothing Then
            RemoveDialPlan = False
            Exit Function
        End If

        m_hKey.DeleteSubKey("DialPlan\" + sUserPrefix)
        RemoveDialPlan = True
    End Function

    Public Function SetDialPlan(ByVal sUserPrefix As String, ByVal objDialPlanReg As cDialPlanReg) As Boolean

        If m_hKey Is Nothing Then
            SetDialPlan = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.CreateSubKey("DialPlan\" + sUserPrefix)
        If hKey Is Nothing Then
            SetDialPlan = False
            Exit Function
        End If

        hKey.SetValue("LineName", objDialPlanReg.m_sLineName)
        hKey.SetValue("CallPrefix", objDialPlanReg.m_sCallPrefix)

        hKey.Close()
        SetDialPlan = True

    End Function

    Public Function GetDialPlan(ByVal sUserPrefix As String, ByRef objDialPlanReg As cDialPlanReg) As Boolean

        If m_hKey Is Nothing Then
            GetDialPlan = False
            Exit Function
        End If

        Dim hKey As RegistryKey

        hKey = m_hKey.CreateSubKey("DialPlan\" + sUserPrefix)
        If hKey Is Nothing Then
            GetDialPlan = False
            Exit Function
        End If

        objDialPlanReg.m_sLineName = hKey.GetValue("LineName", "")
        objDialPlanReg.m_sCallPrefix = hKey.GetValue("CallPrefix", "")

        hKey.Close()
        GetDialPlan = True

    End Function

End Class

