Imports System
Imports System.Text
Imports System.IO
Imports System.Net
Imports System.Net.Sockets

Public Class cTelnetServer

    Public Shared m_objTelnetServer As cTelnetServer

    Public m_sLoginTelnet As String
    Public m_sPwdTelnet As String

    Private m_objClientList As New ArrayList
    Private m_objSocket As Socket = Nothing

    Sub New()
        m_objTelnetServer = Me

        m_sLoginTelnet = "admin"
        m_sPwdTelnet = "admin"
    End Sub

    Private Sub OnServerAccept(ByVal ar As IAsyncResult)

        SyncLock (Me)

            If m_objSocket Is Nothing Then
                Exit Sub
            End If

            Dim objClientSocket As New cTelnetClient

            objClientSocket.m_objSocket = m_objSocket.EndAccept(ar)
            objClientSocket.m_nClientListIndex = m_objClientList.Add(objClientSocket)
            objClientSocket.OnConnected()

            m_objSocket.BeginAccept(New AsyncCallback(AddressOf OnServerAccept), m_objSocket)

        End SyncLock

    End Sub

    Public Function StartServer() As Boolean

        StopServer()

        m_objSocket = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)

        Try

            Dim localEndPoint As IPEndPoint = New IPEndPoint(IPAddress.Any, 4332) ' Open telnet port 4332

            m_objSocket.Bind(localEndPoint)
            m_objSocket.Listen(100)

            m_objSocket.BeginAccept(New AsyncCallback(AddressOf OnServerAccept), m_objSocket)

        Catch e As SocketException

            StartServer = False
            Exit Function

        End Try

        StartServer = True

    End Function

    Public Function IsAuth(ByVal sLogin As String, ByVal sPassword As String) As Boolean

        If (m_sLoginTelnet = sLogin) And (m_sPwdTelnet = sPassword) Then
            IsAuth = True
        Else
            IsAuth = False
        End If

    End Function

    Public Sub StopServer()

        SyncLock (Me)

            If Not m_objSocket Is Nothing Then

                m_objSocket.Close()
                m_objSocket = Nothing

                Dim nCount As Integer
                For nCount = 0 To m_objClientList.Count - 1
                    Dim objTelnetClient As cTelnetClient = m_objClientList.Item(nCount)
                    objTelnetClient.CloseSocket()
                Next

                m_objClientList.Clear()

            End If

        End SyncLock

    End Sub

    Public Sub OnClientDisconnect(ByRef objTelnetClient As cTelnetClient)
        m_objClientList.RemoveAt(objTelnetClient.m_nClientListIndex)
    End Sub

    Public Sub SendCommandToAll(ByVal sCommand As String, ByRef objParamList As ArrayList)

        Dim objTelnetClient As cTelnetClient
        Dim nCount As Integer

        For nCount = 0 To m_objClientList.Count - 1
            objTelnetClient = m_objClientList.Item(nCount)
            objTelnetClient.SendCommand(sCommand, objParamList)
        Next

    End Sub

End Class
