#pragma once

using namespace System;
using namespace System::Collections;
using namespace System::ServiceProcess;
using namespace System::ComponentModel;

#include "ServerSIP/TelnetServer.h"
#include "ServerSIP/ServerSIP.h"

namespace VaxTeleServiceSIP {

	/// <summary>
	/// Summary for VaxTeleServiceSIPWinService
	/// </summary>
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	public ref class VaxTeleServiceSIPWinService : public System::ServiceProcess::ServiceBase
	{
	public:
		VaxTeleServiceSIPWinService()
		{
			InitializeComponent();
			m_objTelnetServer = gcnew cTelnetServer();
		}
	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~VaxTeleServiceSIPWinService()
		{
			if (components)
			{
				delete components;
			}
		}

		cTelnetServer^ m_objTelnetServer;
		cServerSIP^ m_objServerSIP;

		/// <summary>
		/// Set things in motion so your service can do its work.
		/// </summary>
		virtual void OnStart(array<String^>^ args) override
		{
			m_objTelnetServer = gcnew cTelnetServer();
			m_objTelnetServer->StartServer();

			m_objServerSIP = gcnew cServerSIP;
			m_objServerSIP->StartServerSIP();
		}

		/// <summary>
		/// Stop this service.
		/// </summary>
		virtual void OnStop() override
		{
			m_objServerSIP->StopServerSIP();
            m_objTelnetServer->StopServer();

            m_objServerSIP = nullptr;
            m_objTelnetServer = nullptr;
		}

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = gcnew System::ComponentModel::Container();
			this->CanStop = true;
			this->CanPauseAndContinue = true;
			this->AutoLog = true;
			this->ServiceName = L"VaxTeleServiceSIP";
		}
#pragma endregion
	};
}
