// GeneralDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleConfigSIP.h"
#include "VaxTeleConfigDlg.h"
#include "GeneralDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGeneralDlg dialog


CGeneralDlg::CGeneralDlg() : CPropertyPage(CGeneralDlg::IDD)
{
	//{{AFX_DATA_INIT(CGeneralDlg)
	m_objHoldPlayWave = _T("");
	m_objDialTonePlayWave = _T("");
	m_objStealthPlayWave = _T("");
	m_objListenIP = _T("");
	m_objDomainRealm = _T("");
	m_objListenPort = _T("5060");
	m_sServerStatus = _T("");
	//}}AFX_DATA_INIT

	m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button

}


void CGeneralDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGeneralDlg)
	DDX_Text(pDX, IDC_EDIT_SIP_SERVER_HOLD_MUSIC, m_objHoldPlayWave);
	DDX_Text(pDX, IDC_EDIT_SIP_SERVER_DIAL_TONE_MUSIC, m_objDialTonePlayWave);
	DDX_Text(pDX, IDC_EDIT_SIP_SERVER_STEALTH_MUSIC, m_objStealthPlayWave);
	DDX_Text(pDX, IDC_EDIT_SIP_SERVER_LISTEN_IP, m_objListenIP);
	DDX_Text(pDX, IDC_EDIT_SIP_SERVER_DOMAIN_REALM, m_objDomainRealm);
	DDX_Text(pDX, IDC_EDIT_SIP_SERVER_LISTEN_PORT, m_objListenPort);
	DDX_Text(pDX, IDC_STATIC_SERVER_STATUS, m_sServerStatus);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGeneralDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CGeneralDlg)
	ON_BN_CLICKED(IDC_BUTTON_SERVER_START, OnButtonServerStart)
	ON_BN_CLICKED(IDC_BUTTON_SERVER_STOP, OnButtonServerStop)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGeneralDlg message handlers

void CGeneralDlg::OnTelnetCommand(LPCTSTR sCommand, CStringList* pParamList)
{
	if(::lstrcmpi(sCommand, "GetHoldMusic") == 0 && pParamList->GetCount() == 1)
	{
		m_objHoldPlayWave = pParamList->GetHead();
		
		UpdateData(FALSE);
		return;
	}

	if(::lstrcmpi(sCommand, "GetDialToneMusic") == 0 && pParamList->GetCount() == 1)
	{
		m_objDialTonePlayWave = pParamList->GetHead();
		
		UpdateData(FALSE);
		return;
	}

	if(::lstrcmpi(sCommand, "GetStealthMusic") == 0 && pParamList->GetCount() == 1)
	{
		m_objStealthPlayWave = pParamList->GetHead();
		
		UpdateData(FALSE);
		return;
	}

	if(::lstrcmpi(sCommand, "GetCOMM") == 0 && pParamList->GetCount() == 3)
	{
		m_objListenIP    = pParamList->GetAt(pParamList->FindIndex(0));
		m_objListenPort  = pParamList->GetAt(pParamList->FindIndex(1));
		m_objDomainRealm = pParamList->GetAt(pParamList->FindIndex(2));
		
		UpdateData(FALSE);
		return;
	}

	if(::lstrcmpi(sCommand, "SetCOMM") == 0 && pParamList->GetCount() == 3)
	{
		return;
	}

	if(::lstrcmpi(sCommand, "StatusServerSIP") == 0 && pParamList->GetCount() == 1)
	{
		m_sServerStatus = pParamList->GetHead();
		m_sServerStatus.MakeUpper();

		UpdateData(FALSE);

		return;
	}

	if(::lstrcmpi(sCommand, "GetCallCount") == 0 && pParamList->GetCount() == 1)
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_TOTAL_CALLS);
		if(pWnd== NULL) return;

		pWnd->SetWindowText(pParamList->GetAt(pParamList->FindIndex(0)));
		
		return;
	}

	if(::lstrcmpi(sCommand, "GetUserCount") == 0 && pParamList->GetCount() == 1)
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_TOTAL_USERS);
		if(pWnd== NULL) return;

		pWnd->SetWindowText(pParamList->GetAt(pParamList->FindIndex(0)));
		
		return;
	}

	if(::lstrcmpi(sCommand, "GetUsageCPU") == 0 && pParamList->GetCount() == 1)
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_USAGE_CPU);
		if(pWnd== NULL) return;
		
		pWnd->SetWindowText(pParamList->GetAt(pParamList->FindIndex(0)));
	
		return;
	}

	if(::lstrcmpi(sCommand, "GetAvailMEM") == 0 && pParamList->GetCount() == 1)
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_AVAIL_MEME);
		if(pWnd== NULL) return;

		pWnd->SetWindowText(pParamList->GetAt(pParamList->FindIndex(0)));
		
		return;
	}

		
}

BOOL CGeneralDlg::OnSetActive() 
{
	return CPropertyPage::OnSetActive();
}

BOOL CGeneralDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetHoldMusic", NULL);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetDialToneMusic", NULL);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetStealthMusic", NULL);
	
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetCOMM", NULL);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("StatusServerSIP", NULL);

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetCallCount", NULL);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetUserCount", NULL);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetUsageCPU", NULL);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetAvailMEM", NULL);
	
	SetTimer(0, 3000, NULL);
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGeneralDlg::OnButtonServerStart() 
{
	UpdateData();
	
	CStringList objParamList;

	objParamList.AddTail(m_objHoldPlayWave);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("SetHoldMusic", &objParamList);

	objParamList.RemoveAll();
	objParamList.AddTail(m_objDialTonePlayWave);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("SetDialToneMusic", &objParamList);
	
	objParamList.RemoveAll();
	objParamList.AddTail(m_objStealthPlayWave);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("SetStealthMusic", &objParamList);

	objParamList.RemoveAll();
	objParamList.AddTail(m_objListenIP);
	objParamList.AddTail(m_objListenPort);
	objParamList.AddTail(m_objDomainRealm);
	
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("SetCOMM", &objParamList);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("ServerStart", NULL);

}

void CGeneralDlg::OnButtonServerStop() 
{
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("ServerStop", NULL);
}


void CGeneralDlg::OnTimer(UINT nIDEvent) 
{
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetCallCount", NULL);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetUserCount", NULL);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetUsageCPU", NULL);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("GetAvailMEM", NULL);
	
	CPropertyPage::OnTimer(nIDEvent);
}
