// TelnetCmd.h: interface for the CTelnetCmd class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TELNETCMD_H__F3BCB141_ECCB_4F14_860E_A9028B3B3654__INCLUDED_)
#define AFX_TELNETCMD_H__F3BCB141_ECCB_4F14_860E_A9028B3B3654__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTelnetClient;

class CTelnetCmd  
{
public:
	CTelnetCmd();
	virtual ~CTelnetCmd();


private: 

	void PrepareToStr(CStringList* pInputList, CString& objOutputStr);
	void ParseToList(CString sInputStr, CStringList* pOutputList);

public:

	void ShowUsers(CTelnetClient* pTelnetClient);
	void UserInfo(CStringList* pParamList, CTelnetClient* pTelnetClient);
	void AddUser(CStringList* pParamList, CTelnetClient* pTelnetClient);
	void RemoveUser(CStringList* pParamList, CTelnetClient* pTelnetClient);

	void ShowQueues(CTelnetClient* pTelnetClient);
	void QueueInfo(CStringList* pParamList, CTelnetClient* pTelnetClient);
	void AddQueue(CStringList* pParamList, CTelnetClient* pTelnetClient);
	void RemoveQueue(CStringList* pParamList, CTelnetClient* pTelnetClient);

	void ShowLines(CTelnetClient* pTelnetClient);
	void LineInfo(CStringList* pParamList, CTelnetClient* pTelnetClient);
	void AddLine(CStringList* pParamList, CTelnetClient* pTelnetClient);
	void RemoveLine(CStringList* pParamList, CTelnetClient* pTelnetClient);

	void ShowDialPlans(CTelnetClient* pTelnetClient);
	void DialPlanInfo(CStringList* pParamList, CTelnetClient* pTelnetClient);
	void AddDialPlan(CStringList* pParamList, CTelnetClient* pTelnetClient);
	void RemoveDialPlan(CStringList* pParamList, CTelnetClient* pTelnetClient);

	void GetStealthMusic(CTelnetClient* pTelnetClient);
	void SetStealthMusic(CStringList* pParamList, CTelnetClient* pTelnetClient);

	void GetHoldMusic(CTelnetClient* pTelnetClient);
	void SetHoldMusic(CStringList* pParamList, CTelnetClient* pTelnetClient);

	void GetDialToneMusic(CTelnetClient* pTelnetClient);
	void SetDialToneMusic(CStringList* pParamList, CTelnetClient* pTelnetClient);

	void GetCOMM(CTelnetClient* pTelnetClient);
	void SetCOMM(CStringList* pParamList, CTelnetClient* pTelnetClient);

	void StopServer(CTelnetClient* pTelnetClient);
	void StartServer(CTelnetClient* pTelnetClient);

	void InvalidCommand(CTelnetClient* pTelnetClient);
	

};

#endif // !defined(AFX_TELNETCMD_H__F3BCB141_ECCB_4F14_860E_A9028B3B3654__INCLUDED_)
