// TelnetServer.cpp : implementation file
//

#include "stdafx.h"
#include "TelnetServer.h"
#include "TelnetClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TELNET_LISTEN_PORT	4332

/////////////////////////////////////////////////////////////////////////////
// CTelnetServer

CTelnetServer* CTelnetServer::m_pTelnetServer = NULL;

CTelnetServer::CTelnetServer()
{
	AfxSocketInit();
	
	CTelnetServer::m_pTelnetServer = this;
	
	m_pClientList = new CTelnetClientList;
	m_pDestroyList = new CTelnetClientList;

	m_sLoginTelnet = "admin";
	m_sPwdTelnet   = "admin";
}

CTelnetServer::~CTelnetServer()
{
	
	CloseAllClient();

		
	delete m_pClientList;
	delete m_pDestroyList;
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CTelnetServer, CAsyncSocket)
	//{{AFX_MSG_MAP(CTelnetServer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CTelnetServer member functions

void CTelnetServer::FreeMemory()
{
	while(!m_pDestroyList->IsEmpty())
	{
		CTelnetClient* pTelnetClient = m_pDestroyList->RemoveTail();
		pTelnetClient->Close();

		delete pTelnetClient;
	}
}

void CTelnetServer::OnAccept(int nErrorCode) 
{
	FreeMemory();

	CTelnetClient* pTelnetClient = new CTelnetClient;
	Accept(*pTelnetClient);
	
	CAsyncSocket::OnAccept(nErrorCode);

	OnClientConnect(pTelnetClient);
}

void CTelnetServer::OnClientConnect(CTelnetClient* pTelnetClient)
{
	POSITION posList = m_pClientList->AddTail(pTelnetClient);
	pTelnetClient->m_posList = posList;

	pTelnetClient->OnConnected();
}

void CTelnetServer::OnClientDisconnect(CTelnetClient* pTelnetClient)
{
	m_pClientList->RemoveAt(pTelnetClient->m_posList);
	m_pDestroyList->AddTail(pTelnetClient);
}

BOOL CTelnetServer::IsAuth(LPCTSTR sLogin, LPCTSTR sPassword)
{
	return (m_sLoginTelnet == sLogin && m_sPwdTelnet == sPassword);
}

BOOL CTelnetServer::StartServer()
{
	if(!CAsyncSocket::Create(TELNET_LISTEN_PORT)) return FALSE;

	CAsyncSocket::Listen();

	return TRUE;
}

void CTelnetServer::StopServer()
{
	CAsyncSocket::Close();

	CloseAllClient();
}

void CTelnetServer::SendCommandToAll(LPCTSTR sCommand, CStringList* pParamList)
{
	for(POSITION pos = m_pClientList->GetHeadPosition(); pos != NULL;)
	{
		CTelnetClient* pTelnetClient = m_pClientList->GetNext(pos);
		pTelnetClient->SendCommand(sCommand, pParamList);
	}
}

void CTelnetServer::CloseAllClient()
{
	FreeMemory();
	
	while(!m_pClientList->IsEmpty())
	{
		CTelnetClient* pTelnetClient = m_pClientList->RemoveTail();
		pTelnetClient->Close();

		delete pTelnetClient;
	}
}
