using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace VaxTeleConfigSIP
{
    public partial class AddDialPlanForm : Form
    {
        public AddDialPlanForm()
        {
            InitializeComponent();
        }

        public void OnTelnetCommand(string sCommand, ref ArrayList objParamList)
        {
            if(String.Compare(sCommand, "AddLine", true) == 0 && objParamList.Count == 1)
            {
                ComboLine.Items.Add(objParamList[0]);
                return;
            }

            if(String.Compare(sCommand, "RemoveLine", true) == 0 && objParamList.Count == 1)
            {
                int nIndex = ComboLine.FindStringExact((string) objParamList[0]);
                if(nIndex == -1) return;
                            
                ComboLine.Items.RemoveAt(nIndex);
                return;
            }

            if(String.Compare(sCommand, "ShowLines", true) == 0)
            {
                for(int nCount = 0; nCount < objParamList.Count; nCount++)
                    ComboLine.Items.Add(objParamList[nCount]);
                
                if(ComboLine.Items.Count > 0)
                    ComboLine.SelectedIndex = 0;

                return;
            }

            if(String.Compare(sCommand, "ShowDialPlans", true) == 0)
            {
                for(int nCount = 0; nCount < objParamList.Count; nCount++)
                {
                    string sDialPlan = (string) objParamList[nCount];

                    ArrayList objValueList = new ArrayList();
                    MainForm.m_objMainForm.ParseToList(sDialPlan, ref objValueList);

                    ListViewItem ListItem = ListDialPlan.Items.Add((string) objValueList[0]);
                    ListItem.SubItems.Add((string) objValueList[1]);
                    ListItem.SubItems.Add((string)objValueList[2]);
                }

                return;
            }
                
            if( String.Compare(sCommand, "AddDialPlan", true) == 0 && objParamList.Count == 3)
            {
                ListViewItem objListItem = ListDialPlan.Items.Add((string)objParamList[0]);
                objListItem.SubItems.Add((string)objParamList[1]);
                objListItem.SubItems.Add((string)objParamList[2]);
                
                return;
            }

            if(String.Compare(sCommand, "RemoveDialPlan", true) == 0 && objParamList.Count == 1)
            {
                ListViewItem objListItem = ListDialPlan.FindItemWithText((string)objParamList[0]);
                if(objListItem == null) return;
                    
                ListDialPlan.Items.Remove(objListItem);

                return;
            }
        }
                    
        private void AddDialPlanForm_Load(object sender, EventArgs e)
        {
            ListDialPlan.Columns.Add("User Prefix", 120, HorizontalAlignment.Left);
            ListDialPlan.Columns.Add("Line Name", 120, HorizontalAlignment.Left);
            ListDialPlan.Columns.Add("Call Prefix", 120, HorizontalAlignment.Left);
                        
            MainForm.m_objMainForm.SendCommand("ShowDialPlans");
        }

        private void BtnAdd_Click(object sender, EventArgs e)
        {
            if (EditUserPrefix.Text.Length == 0)
            {
                MessageBox.Show("Please enter the user dial phone no prefix.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            for (int nCount = 0; nCount < ListDialPlan.Items.Count; nCount++)
            {
                if (EditUserPrefix.Text == ListDialPlan.Items[nCount].Text)
                {
                    MessageBox.Show("Dial plan that user dials phone no with prefix " + EditUserPrefix.Text + " is already exist.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }
            }

            if (ComboLine.SelectedIndex == -1)
            {
                MessageBox.Show("Please select the line.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            ArrayList objParamList = new ArrayList();

            objParamList.Add(EditUserPrefix.Text);
            objParamList.Add(ComboLine.Text);
            objParamList.Add(EditCallPrefix.Text);

            MainForm.m_objMainForm.SendCommand("AddDialPlan", ref objParamList);
        }

        private void BtnRemove_Click(object sender, EventArgs e)
        {
            if (ListDialPlan.SelectedItems.Count == 0)
            {
                MessageBox.Show("Please select a dial plan.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            ArrayList objParamList = new ArrayList();
            objParamList.Add(ListDialPlan.SelectedItems[0].Text);

            MainForm.m_objMainForm.SendCommand("RemoveDialPlan", ref objParamList);
       }

    }
}