using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace VaxTeleConfigSIP
{
    public partial class MainForm : Form
    {
        public static MainForm m_objMainForm;

        private GeneralForm m_objGeneralForm = new GeneralForm();
        private AddLoginForm m_objAddLoginForm = new AddLoginForm();
        private AddLineForm m_objAddLineForm = new AddLineForm();
        private AddDialPlanForm m_objAddDialPlanForm = new AddDialPlanForm();
        private AddQueueForm m_objAddQueueForm = new AddQueueForm();
        private ErrorLogForm m_objErrorLogForm = new ErrorLogForm();
        private StatusLogForm m_objStatusLogForm = new StatusLogForm();

        public cTelnetClient m_objTelnetClient = new cTelnetClient();
    
        public MainForm()
        {
            m_objMainForm = this;
            InitializeComponent();
        }
                
        private void MainForm_Load(object sender, EventArgs e)
        {
            AuthForm objAuthForm = new AuthForm();

            objAuthForm.m_objTelnetClient = m_objTelnetClient;
            objAuthForm.ShowDialog();

            if(objAuthForm.m_bConnected == false)
            {
                Close();
                return;
            }

            m_objGeneralForm.TopLevel = false;
            m_objGeneralForm.Visible = true;
            m_objGeneralForm.FormBorderStyle = FormBorderStyle.None;
            m_objGeneralForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[0].Controls.Add(m_objGeneralForm);

            m_objAddLoginForm.TopLevel = false;
            m_objAddLoginForm.Visible = true;
            m_objAddLoginForm.FormBorderStyle = FormBorderStyle.None;
            m_objAddLoginForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[1].Controls.Add(m_objAddLoginForm);

            m_objAddLineForm.TopLevel = false;
            m_objAddLineForm.Visible = true;
            m_objAddLineForm.FormBorderStyle = FormBorderStyle.None;
            m_objAddLineForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[2].Controls.Add(m_objAddLineForm);

            m_objAddDialPlanForm.TopLevel = false;
            m_objAddDialPlanForm.Visible = true;
            m_objAddDialPlanForm.FormBorderStyle = FormBorderStyle.None;
            m_objAddDialPlanForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[3].Controls.Add(m_objAddDialPlanForm);

            m_objAddQueueForm.TopLevel = false;
            m_objAddQueueForm.Visible = true;
            m_objAddQueueForm.FormBorderStyle = FormBorderStyle.None;
            m_objAddQueueForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[4].Controls.Add(m_objAddQueueForm);

            m_objErrorLogForm.TopLevel = false;
            m_objErrorLogForm.Visible = true;
            m_objErrorLogForm.FormBorderStyle = FormBorderStyle.None;
            m_objErrorLogForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[5].Controls.Add(m_objErrorLogForm);

            m_objStatusLogForm.TopLevel = false;
            m_objStatusLogForm.Visible = true;
            m_objStatusLogForm.FormBorderStyle = FormBorderStyle.None;
            m_objStatusLogForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[6].Controls.Add(m_objStatusLogForm);
        
        }

        private void TabCtrlMain_DrawItem(object sender, DrawItemEventArgs e)
        {
            Graphics g = e.Graphics;
            Font f = new Font(e.Font, FontStyle.Bold);
            SolidBrush b = new SolidBrush(SystemColors.Control);
            g.FillRectangle(b, e.Bounds);

            b.Color = Color.Black;
            g.DrawString(this.TabCtrlMain.TabPages[e.Index].Text, e.Font, b, e.Bounds.X + 2, e.Bounds.Y + 2);

            b.Dispose();
            f.Dispose();
        }

        public void SetPageTitle(string sTitle, int nPageNo)
        {
            TabCtrlMain.TabPages[nPageNo].Text = sTitle;
        }

        public void InvokeTelnetRecv(string sCommand, ref ArrayList objParamList)
        {
            Object[] MethodParam = new Object[] {sCommand, objParamList};
            Invoke(new OnTelnetRecv(OnTelnetCommand), MethodParam);
        }

        public delegate void OnTelnetRecv(string sCommand, ref ArrayList objParamList);

        public void OnTelnetCommand(string sCommand, ref ArrayList objParamList)
        {
            if(String.Compare(sCommand, "GetDialToneMusic", true) == 0 || String.Compare(sCommand, "GetStealthMusic", true) == 0 || String.Compare(sCommand, "GetHoldMusic", true) == 0 || String.Compare(sCommand, "StatusServerSIP", true) == 0)
            {
                m_objGeneralForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            if (String.Compare(sCommand, "GetCallCount", true) == 0 || String.Compare(sCommand, "GetUserCount", true) == 0 || String.Compare(sCommand, "GetUsageCPU", true) == 0 || String.Compare(sCommand, "GetAvailMEM", true) == 0)
            {
                m_objGeneralForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            if(String.Compare(sCommand, "GetCOMM", true) == 0 || String.Compare(sCommand, "SetCOMM", true) == 0)
            {
                m_objGeneralForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            ///////////////////////////////////////

            if(String.Compare(sCommand, "ShowUsers", true) == 0)
            {
                m_objAddLoginForm.OnTelnetCommand(sCommand, ref objParamList);
                m_objAddQueueForm.OnTelnetCommand(sCommand, ref objParamList);
                m_objAddLineForm.OnTelnetCommand(sCommand, ref objParamList);

                return;
            }

            if(String.Compare(sCommand, "RemoveUser", true) == 0 || String.Compare(sCommand, "AddUser", true) == 0)
            {
                m_objAddLoginForm.OnTelnetCommand(sCommand, ref objParamList);
                m_objAddQueueForm.OnTelnetCommand(sCommand, ref objParamList);
                m_objAddLineForm.OnTelnetCommand(sCommand, ref objParamList);

                return;
            }

            if(String.Compare(sCommand, "UpdateUser", true) == 0 || String.Compare(sCommand, "UserInfo", true) == 0)
            {
                m_objAddLoginForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            ///////////////////////////////////////

            if(String.Compare(sCommand, "RemoveQueue", true) == 0 || String.Compare(sCommand, "AddQueue", true) == 0 || String.Compare(sCommand, "ShowQueues", true) == 0)
            {
                m_objAddQueueForm.OnTelnetCommand(sCommand, ref objParamList);
                m_objAddLineForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            if(String.Compare(sCommand, "UpdateQueue", true) == 0 || String.Compare(sCommand, "QueueInfo", true) == 0)
            {
                m_objAddQueueForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            ////////////////////////////////////////

            if(String.Compare(sCommand, "RemoveLine", true) == 0 || String.Compare(sCommand, "AddLine", true) == 0 || String.Compare(sCommand, "ShowLines", true) == 0)
            {
                m_objAddLineForm.OnTelnetCommand(sCommand, ref objParamList);
                m_objAddDialPlanForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            if(String.Compare(sCommand, "UpdateLine", true) == 0 || String.Compare(sCommand, "LineInfo", true) == 0 || String.Compare(sCommand, "ShowLines", true) == 0)
            {
                m_objAddLineForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            ////////////////////////////////////////

            if(String.Compare(sCommand, "ShowDialPlans", true) == 0)
            {
                m_objAddDialPlanForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            if(String.Compare(sCommand, "RemoveDialPlan", true) == 0 || String.Compare(sCommand, "AddDialPlan", true) == 0)
            {
                m_objAddDialPlanForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            if(String.Compare(sCommand, "UpdateDialPlan", true) == 0 || String.Compare(sCommand, "DialPlanInfo", true) == 0)
            {
                m_objAddDialPlanForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            ////////////////////////////////////////

            if(String.Compare(sCommand, "ErrorLog", true) == 0)
            {
                m_objErrorLogForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            if(String.Compare(sCommand, "StatusLog", true) == 0)
            {
                m_objStatusLogForm.OnTelnetCommand(sCommand, ref objParamList);
                return;
            }

            ////////////////////////////////////////

            if(String.Compare(sCommand, "MSG", true) == 0 && objParamList.Count == 1)
            {
                MessageBox.Show((string) objParamList[0], "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

        }
        
        public void SendCommand(string sCommand, ref ArrayList objParamList)
        {
            m_objTelnetClient.SendCommand(sCommand, ref objParamList);
        }

        public void SendCommand(string sCommand)
        {
            m_objTelnetClient.SendCommand(sCommand);
        }

        public void ParseToList(string sString, ref ArrayList objStrList)
        {
            while(sString.Length != 0)
            {
                int nEnd = sString.IndexOf(",");

                if(nEnd == -1)
                {
                    objStrList.Add(sString);
                    break;
                }

                objStrList.Add(sString.Substring(0, nEnd));
                sString = sString.Remove(0, nEnd + 1);
            }
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            m_objTelnetClient.CloseSocket();
        }
    }
}