using System;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Collections;

class cTelnetServer
{
    public static cTelnetServer m_objTelnetServer;

    public string m_sLoginTelnet;
    public string m_sPwdTelnet;

    private ArrayList m_objClientList = new ArrayList();
    private Socket m_objSocket = null;

    public cTelnetServer()
    {
        m_objTelnetServer = this;

        m_sLoginTelnet = "admin";
        m_sPwdTelnet = "admin";
    }

    private void OnServerAccept(IAsyncResult ar)
    {
        lock (this)
        {
            if (m_objSocket == null)
                return;
                      
            cTelnetClient objClientSocket = new cTelnetClient();

            objClientSocket.m_objSocket = m_objSocket.EndAccept(ar);
            objClientSocket.m_nClientListIndex = m_objClientList.Add(objClientSocket);
            objClientSocket.OnConnected();

            m_objSocket.BeginAccept(new AsyncCallback(OnServerAccept), m_objSocket);
        }
    }

    public Boolean StartServer()
    {
        StopServer();

        m_objSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

        try
        {
            IPEndPoint localEndPoint = new IPEndPoint(IPAddress.Any, 4332);

            m_objSocket.Bind(localEndPoint);
            m_objSocket.Listen(100);

            m_objSocket.BeginAccept(new AsyncCallback(OnServerAccept), m_objSocket);
        }
        catch (SocketException e)
        {
            return false;
        }

        return true;
    }

    public Boolean IsAuth(string sLogin, string sPassword)
    {
        return ((m_sLoginTelnet == sLogin) && (m_sPwdTelnet == sPassword));
    }

    public void StopServer()
    {
        lock (this)
        {
            if (m_objSocket != null)
            {
                m_objSocket.Close();
                m_objSocket = null;
            }

            for (int nCount = 0; nCount < m_objClientList.Count; nCount++)
            {
                cTelnetClient objTelnetClient = (cTelnetClient)m_objClientList[nCount];
                objTelnetClient.CloseSocket();
            }

            m_objClientList.Clear();
        }
    }

    public void OnClientDisconnect(ref cTelnetClient objTelnetClient)
    {
        m_objClientList.RemoveAt(objTelnetClient.m_nClientListIndex);
    }

    public void SendCommandToAll(string sCommand, ref ArrayList objParamList)
    {
        cTelnetClient objTelnetClient;
        
        for(int nCount = 0; nCount < m_objClientList.Count; nCount++)
        {
            objTelnetClient = (cTelnetClient) m_objClientList[nCount];
            objTelnetClient.SendCommand(sCommand, ref objParamList);
        }
    }
}

